/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource['epages.io.text']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.io.text'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.io.Text $Revision: 1.7 $

*/
dojo.provide('epages.io.text');

epages.io.Text = function (/*String*/url) {
	// summary:
	//		Loads text data from url and set the received text data to the target object.
	// example:
	// 	  epages.io.Text('http://www.mydomain.de/header.text', $(header));
	if (url === undefined){
		return;
	}
	return this.load(url);
};

epages.io.Text.prototype = {
	load: function (/*String*/url) {
		// summary:
		//		Loads text data from url and set the received text data to the target object.
		// example:
		// 	  textLoader = new epages.io.Text();
		//		textLoader.load('http://www.mydomain.de/header.text', $(header));
		var targetObject = {};
	  dojo.xhrGet({
	    url:  url,
	    sync: true,
	    load: function(data, evt){
	      targetObject.text = data;
	    },
	    handleAs: "text"
	  });
	  return targetObject.text; //String
	},

	test: function(/*epages.Test*/eTest) {
		// summary:
		//		test this package
		// example:
		// 	  var package = new epages.io.Text();
		//		boolean = package.test(eTest);
		//		// returns true if all test are successfully
		eTest.setPlanned(2);
		eTest.ok(1, 'loaded');

		var text = this.load('htmlTest.inc');
		eTest.ok(text == 'Header loaded successfully.', 'load header');

		// closing async test
		return eTest.planned == eTest.correct ? true : false; //Boolean
	}
};

}
